<?php

// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_AUXBASE")) return;
define("_ECRIRE_INC_AUXBASE", "1");
include('inc_globalbase.php3');
// Description PHP des tables SQL auxiliaires

$spip_tables_auxiliaires  = array(
	'spip_petitions',
	'spip_visites_temp',
	'spip_visites',
	'spip_visites_articles',
	'spip_referers_temp',
	'spip_referers',
	'spip_referers_articles',
	'spip_auteurs_articles',
	'spip_auteurs_rubriques',
	'spip_auteurs_messages',
	'spip_documents_articles',
	'spip_documents_rubriques',
	'spip_documents_breves',
	'spip_mots_articles',
	'spip_mots_breves',
	'spip_mots_rubriques',
	'spip_mots_syndic',
	'spip_mots_forum',
	'spip_forum_cache',
	'spip_caches',
	'spip_inclure_caches',
	'spip_squelettes',
	'spip_meta',
	'spip_index_articles',
	'spip_index_auteurs',
	'spip_index_breves',
	'spip_index_mots',
	'spip_index_rubriques',
	'spip_index_syndic',
	'spip_index_dico'
	);

 $spip_petitions = array(
		"id_article"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"email_unique"	=> "char(3) NOT NULL",
		"site_obli"	=> "char(3) NOT NULL",
		"site_unique"	=> "char(3) NOT NULL",
		"message"	=> "char(3) NOT NULL",
		"texte"	=> "longblob NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_petitions_key = array(
		"PRIMARY KEY"	=> "id_article");

$spip_visites_temp = array(
		"ip"	=> "INTEGER UNSIGNED NOT NULL",
		"type"	=> "ENUM('article', 'rubrique', 'breve', 'autre') NOT NULL",
		"id_objet"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_visites_temp_key = array(
		"PRIMARY KEY"	=> "type, id_objet, ip");

$spip_visites = array(
		"date"	=> "DATE NOT NULL",
		"visites"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_visites_key = array(
		"PRIMARY KEY"	=> "date");

$spip_visites_articles = array(
		"date"	=> "DATE NOT NULL",
		"id_article"	=> "INTEGER UNSIGNED NOT NULL",
		"visites"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_visites_articles_key = array(
		"PRIMARY KEY"	=> "date, id_article");

$spip_referers_temp = array(
		"ip"	=> "INTEGER UNSIGNED NOT NULL",
		"referer"	=> "VARCHAR(255) NOT NULL",
		"referer_md5"	=> "BIGINT UNSIGNED NOT NULL",
		"type"	=> "ENUM('article', 'rubrique', 'breve', 'autre') NOT NULL",
		"id_objet"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_referers_temp_key = array(
		"PRIMARY KEY"	=> "type, id_objet, referer_md5, ip");

$spip_referers = array(
		"referer_md5"	=> "BIGINT UNSIGNED NOT NULL",
		"date"	=> "DATE NOT NULL",
		"referer"	=> "VARCHAR(255) NOT NULL",
		"visites"	=> "INTEGER UNSIGNED NOT NULL",
		"visites_jour"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_referers_key = array(
		"PRIMARY KEY"	=> "referer_md5");

$spip_referers_articles = array(
		"id_article"	=> "INTEGER UNSIGNED NOT NULL",
		"referer_md5"	=> "BIGINT UNSIGNED NOT NULL",
		"date"	=> "DATE NOT NULL",
		"referer"	=> "VARCHAR(255) NOT NULL",
		"visites"	=> "INTEGER UNSIGNED NOT NULL",
		"maj"	=> "TIMESTAMP");

$spip_referers_articles_key = array(
		"PRIMARY KEY"	=> "id_article, referer_md5",
		"KEY referer_md5"	=> "referer_md5");

$spip_auteurs_articles = array(
		"id_auteur"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_article"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_auteurs_articles_key = array(
		"KEY id_auteur"	=> "id_auteur",
		"KEY id_article"	=> "id_article");

$spip_auteurs_rubriques = array(
		"id_auteur"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_rubrique"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_auteurs_rubriques_key = array(
		"KEY id_auteur"	=> "id_auteur",
		"KEY id_rubrique"	=> "id_rubrique");

$spip_auteurs_messages = array(
		"id_auteur"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_message"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"vu"	=> "CHAR(3) NOT NULL");

$spip_auteurs_messages_key = array(
		"KEY id_auteur"	=> "id_auteur",
		"KEY id_message"	=> "id_message");


$spip_documents_articles = array(
		"id_document"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_article"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_documents_articles_key = array(
		"KEY id_document"	=> "id_document",
		"KEY id_article"	=> "id_article");

$spip_documents_rubriques = array(
		"id_document"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_rubrique"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_documents_rubriques_key = array(
		"KEY id_document"	=> "id_document",
		"KEY id_rubrique"	=> "id_rubrique");

$spip_documents_breves = array(
		"id_document"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_breve"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_documents_breves_key = array(
		"KEY id_document"	=> "id_document",
		"KEY id_breve"	=> "id_breve");

$spip_mots_articles = array(
		"id_mot"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_article"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_mots_articles_key = array(
		"KEY id_mot"	=> "id_mot",
		"KEY id_article"	=> "id_article");

$spip_mots_breves = array(
		"id_mot"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_breve"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_mots_breves_key = array(
		"KEY id_mot"	=> "id_mot",
		"KEY id_breve"	=> "id_breve");

$spip_mots_rubriques = array(
		"id_mot"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_rubrique"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_mots_rubriques_key = array(
		"KEY id_mot"	=> "id_mot",
		"KEY id_rubrique"	=> "id_rubrique");

$spip_mots_syndic = array(
		"id_mot"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_syndic"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_mots_syndic_key = array(
		"KEY id_mot"	=> "id_mot",
		"KEY id_syndic"	=> "id_syndic");

$spip_mots_forum = array(
		"id_mot"	=> "bigint(21) DEFAULT '0' NOT NULL",
		"id_forum"	=> "bigint(21) DEFAULT '0' NOT NULL");

$spip_mots_forum_key = array(
		"KEY id_mot"	=> "id_mot",
		"KEY id_forum"	=> "id_forum");

$spip_meta = array(
		"nom"	=> "VARCHAR(255) NOT NULL",
		"valeur"	=> "VARCHAR(255) DEFAULT ''",
		"maj"	=> "TIMESTAMP");

$spip_meta_key = array(
		"PRIMARY KEY"	=> "nom");

$spip_index_articles = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_article"	=> "int unsigned NOT NULL");

$spip_index_articles_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_article"	=> "id_article");

$spip_index_auteurs = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_auteur"	=> "int unsigned NOT NULL");

$spip_index_auteurs_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_auteur"	=> "id_auteur");

$spip_index_breves = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_breve"	=> "int unsigned NOT NULL");

$spip_index_breves_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_breve"	=> "id_breve");

$spip_index_mots = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_mot"	=> "int unsigned NOT NULL");

$spip_index_mots_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_mot"	=> "id_mot");

$spip_index_rubriques = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_rubrique"	=> "int unsigned NOT NULL");

$spip_index_rubriques_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_rubrique"	=> "id_rubrique");

$spip_index_syndic = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"points"	=> "int unsigned DEFAULT '0' NOT NULL",
		"id_syndic"	=> "int unsigned NOT NULL");

$spip_index_syndic_key = array(
		"KEY `hash`"	=> "`hash`",
		"KEY id_syndic"	=> "id_syndic");

$spip_index_dico = array(
		"`hash`"	=> "bigint unsigned NOT NULL",
		"dico"	=> "VARCHAR(30) NOT NULL");

$spip_index_dico_key = array(
		"PRIMARY KEY"	=> "dico");

$spip_caches = array(
		"hache"	=> "bigint unsigned NOT NULL",
		"naissance"	=>  "bigint unsigned",
		"vetuste"	=>  "varchar(255)",
		"process_ins"	=>  "varchar(255)",
		"texte"	=> "longblob NOT NULL");

$spip_caches_key = array(
		"PRIMARY KEY"	=> "hache");

$spip_inclure_caches = array(
		"hache"		=> "bigint unsigned NOT NULL",
		"inclure"	=> "bigint unsigned NOT NULL");

$spip_inclure_caches_key = array(
				 "KEY"	=> "hache",
				 "KEY"	=> "inclure");

$spip_squelettes = array(
		"hache"	=> "bigint unsigned NOT NULL",
		"naissance"	=>  "bigint unsigned",
		"vetuste"	=>  "varchar(255)",
		"process_ins"	=>  "varchar(255)",
		"texte"	=> "longblob NOT NULL");

$spip_squelettes_key = array(
		"PRIMARY KEY"	=> "hache"
);

?>
