<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CALCUL")) return;
define("_INC_CALCUL", "1");

// inc-calcul.php3 excute un squelette.

if (file_exists("mes_fonctions.php3")) {
	include_local ("mes_fonctions.php3");
}

include_ecrire("inc_index.php3");
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire("inc_lang.php3");
include_ecrire("inc_documents.php3");

tester_variable('espace_logos',3);  // HSPACE=xxx VSPACE=xxx pour les logos (#LOGO_ARTICLE)
tester_variable('espace_images',3);  // HSPACE=xxx VSPACE=xxx pour les images integrees (<IMG1>)

if (file_exists("inc-urls.php3")) {
	include_local ("inc-urls.php3");
}
else {
	include_local ("inc-urls-dist.php3");
}

function calcule_page($fond, $cache, $contexte, $id_r, $lang='') 
{
  static $fonctions_squelettes = '';
  global $dossier_squelettes;
 
  $d = "$dossier_squelettes/mon-chercher.php3";
  include((file_exists($d) ? $d : "inc-chercher.php3"));

  // prendre en compte le bon repertoire (pas grave si 2 / dans l'arborescence)
  $fond = chercher_squelette($fond, $id_r, 
			     $dossier_squelettes ? "$dossier_squelettes/" :'');

  if ($lang)
    {
	lang_select($lang);
	if (@file_exists("$fond.$lang.html")) $fond = "$fond.$lang";
    }
  if (!$fonctions_squelettes[$fond])
    $fonctions_squelettes[$fond] =  ramener_squelette($fond);
  $timer_a = explode(" ", microtime());
  $page =  $fonctions_squelettes[$fond]($contexte, $cache);
  $timer_b = explode(" ", microtime());
  $timer = ceil(1000*($timer_b[0] + $timer_b[1] - $timer_a[0] - $timer_a[1]));
  spip_log("Page $fond: " . strlen($page[0]) . " octets, $timer ms");
  return $page;
}

function cherche_page($fond, $cache, $contexte, $id_r, $rech='', $lang='', $glob='') 
{
  $page = calcule_page($fond, $cache, $contexte, $id_r, $lang) ;
  $texte = $page[0];
  if ($rech)
    {
      include_ecrire("inc_surligne.php3");
      spip_log("Recherche : $rech");
      $texte = surligner_mots($texte, $rech);
    } 
  $pi = (strpos($texte,'<?')=== false);

  return array('texte' => (($pi || (!$glob)) ? $texte :
			   ('<'."?php $glob ?".'>'.$texte)),
	       'type' => 'string',
	       'process_ins' => ($pi ? '' : 'php'),
	       'invalideurs' => $page[1]);
}

function calculer_page_globale($fond, $cache, $var_recherche) {
  global $HTTP_GET_VARS;

	$contexte = '';
	$contexte_defaut = array('id_parent', 'id_rubrique', 'id_article', 'id_auteur',
				 'id_breve', 'id_forum', 'id_secteur', 'id_syndic', 'id_syndic_article', 'id_mot', 'id_groupe', 'id_document');
	reset($contexte_defaut);
	while (list(, $val) = each($contexte_defaut)) {
		if ($HTTP_GET_VARS[$val]) {
			$contexte[$val] = intval($HTTP_GET_VARS[$val]);
		}
	}
	if ($GLOBALS['date'])
		$contexte['date'] = $contexte['date_redac'] = normaliser_date($GLOBALS['date']);
	else
		$contexte['date'] = $contexte['date_redac'] = date("Y-m-d H:i:s");

	$lang = lire_meta('langue_site');
	if ($contexte['lang'])
		$lang = $contexte['lang'];	// si inc-urls veut fixer la langue

	// Calcul de la rubrique associee a la requete
	// (selection de squelette specifique)

	if ($id = $contexte['id_rubrique']) {
		$id_rubrique_fond = $id;
		if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id'")))
			if ($row['lang']) $lang = $row['lang'];
	}
	else if ($id  = $contexte['id_breve']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_breves WHERE id_breve='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_syndic']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_syndic WHERE id_syndic='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_article']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique,lang FROM spip_articles WHERE id_article='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row['lang']) $lang = $row['lang'];
		}
	}
	else {
		$id_rubrique_fond = 0;
	}

	reset($contexte_defaut);
	$signale_globals = "";
	while (list($key, $val) = each($contexte_defaut)) {
		if ($contexte[$val]) {
			$GLOBALS[$val] = $contexte[$val];
			$signale_globals .= '$GLOBALS[\''.$val.'\'] = '.intval($contexte[$val]).";";
		}
	}
	return cherche_page($fond, $cache, $contexte, $id_rubrique_fond,
			    $var_recherche, $lang, $signale_globals);
}


//
// Ajouter le &var_recherche=toto dans les boucles de recherche
//
function url_var_recherche($url) {
	if ($GLOBALS['HTTP_GET_VARS']['recherche'] && !ereg("var_recherche", $url)) {
		$url .= strpos($url, '?') ? '&' : '?';
		$url .= "var_recherche=".urlencode($GLOBALS['recherche']);
	}
	return $url;
}

//
// Retrouver le logo d'un objet (et son survol)
//

function cherche_image_nommee($nom) {
	$formats = array ('gif', 'jpg', 'png');
	while (list(, $format) = each($formats))
		if (file_exists('IMG/'.$nom.'.'.$format))
			return ($nom.'.'.$format);
}

function cherche_image($id_objet, $type_objet) {
	$image = array('', '');

	// cherche l'image liee a l'objet
	$image[0] = cherche_image_nommee($type_objet.'on'.$id_objet);

	// cherche un survol
	if ($image[0]) {
		$image[1] = cherche_image_nommee($type_objet.'off'.$id_objet);
	}

	return $image;
}


function image_document($id_document){
	$query = "SELECT * FROM spip_documents WHERE id_document = $id_document";
	$result = spip_query($query);
	if ($row = spip_fetch_array($result)) {
		$id_document = $row['id_document'];
		$id_type = $row['id_type'];
		$titre = propre($row ['titre']);
		$descriptif = propre($row['descriptif']);
		$fichier = generer_url_document($id_document);
		$largeur = $row['largeur'];
		$hauteur = $row['hauteur'];
		$taille = $row['taille'];
		$mode = $row['mode'];
		$id_vignette = $row['id_vignette'];

		// recuperer la vignette pour affichage inline
		if ($id_vignette) {
			$query_vignette = "SELECT * FROM spip_documents WHERE id_document = $id_vignette";
			$result_vignette = spip_query($query_vignette);
			if ($row_vignette = @spip_fetch_array($result_vignette)) {
				$fichier_vignette = generer_url_document($id_vignette);
				$largeur_vignette = $row_vignette['largeur'];
				$hauteur_vignette = $row_vignette['hauteur'];
			}
		}
		else if ($mode == 'vignette') {
			$fichier_vignette = $fichier;
			$largeur_vignette = $largeur;
			$hauteur_vignette = $hauteur;
		}
		// si pas de vignette, utiliser la vignette par defaut du type du document
		if (!$fichier_vignette) {
			// on construira le lien en fonction du type de doc
			$result_type = spip_query("SELECT * FROM spip_types_documents WHERE id_type = $id_type");
			if ($type = @spip_fetch_object($result_type)) {
				$extension = $type->extension;
			}
			list($fichier_vignette, $largeur_vignette, $hauteur_vignette) = vignette_par_defaut($extension);
		}

		$image[0] = $fichier_vignette;
		return $image;
	}

}

function image_article($id_article){
	return cherche_image($id_article,'art');
}

function image_auteur($id_auteur){
	return cherche_image($id_auteur,'aut');
}

function image_breve($id_breve){
	return cherche_image($id_breve,'breve');
}

function image_site($id_syndic){
	return cherche_image($id_syndic,'site');
}

function image_mot($id_mot){
	return cherche_image($id_mot,'mot');
}

function image_rubrique($id_rubrique) {
	// Recherche recursive vers les rubriques parentes (y compris racine)
	for (;;) {
		$image = cherche_image($id_rubrique, 'rub');
		if ($image[0]) break;
		$result = spip_query("SELECT id_parent FROM spip_rubriques WHERE id_rubrique='$id_rubrique'");
		if ($row = spip_fetch_array($result)) {
			$id_rubrique = $row['id_parent'];
		}
		else break;
	}

	return $image;
}

function IMG_image($im) {
	// ajoute les "IMG/" devant les noms des images trouvees
	if ($im[0])
		$im[0] = 'IMG/'.$im[0];
	if ($im[1])
		$im[1] = 'IMG/'.$im[1];
	return $im;
}


// Renvoie le code html pour afficher le logo, avec ou sans survol, avec ou sans lien, etc.
function affiche_logos($arton, $artoff, $lien, $align) {
	global $num_survol;
	global $espace_logos;

	$num_survol++;
	if ($arton) {
		//$imgsize = @getimagesize("$arton");
		//$taille_image = ereg_replace("\"","'",$imgsize[3]);
		if ($align) $align="align='$align' ";

		$milieu = "<img src='$arton' $align".
			" name='image$num_survol' ".$taille_image." border='0' alt=''".
			" hspace='$espace_logos' vspace='$espace_logos' class='spip_logos' />";

		if ($artoff) {
			if ($lien) {
				$afflien = "<a href='$lien'";
				$afflien2 = "a>";
			}
			else {
				$afflien = "<div";
				$afflien2 = "div>";
			}
			$milieu = "$afflien onMouseOver=\"image$num_survol.src=".
				"'$artoff'\" onMouseOut=\"image$num_survol.src=".
				"'$arton'\">$milieu</$afflien2";
		}
		else if ($lien) {
			$milieu = "<a href='$lien'>$milieu</a>";
		}
	} else {
		$milieu="";
	}
	return $milieu;
}


// Critere {branche} : recuperer les descendants d'une rubrique

function calcul_generation ($generation) {
	$lesfils = array();
	$result = spip_query("SELECT id_rubrique FROM spip_rubriques WHERE id_parent IN ($generation)");
	while ($row = spip_fetch_array($result))
		$lesfils[] = $row['id_rubrique'];
	return join(",",$lesfils);
}
function calcul_branche ($generation) {
	if ($generation) {
		$branche[] = $generation;
		while ($generation = calcul_generation ($generation))
			$branche[] = $generation;
		return join(",",$branche);
	} else
		return '0';
}

//
// fonction standard de calcul de la balise #INTRODUCTION
// on peut la surcharger en definissant dans mes_fonctions.php3 :
// function introduction($type,$texte,$descriptif) {...}
//
function calcul_introduction ($type, $texte, $chapo='', $descriptif='') {
	if (function_exists("introduction"))
		return introduction ($type, $texte, $chapo, $descriptif);

	switch ($type) {
		case 'articles':
			if ($descriptif)
				return propre($descriptif);
			else if (substr($chapo, 0, 1) == '=')	// article virtuel
				return '';
			else
				return PtoBR(propre(supprimer_tags(couper_intro($chapo."\n\n\n".$texte, 500))));
			break;
		case 'breves':
			return PtoBR(propre(supprimer_tags(couper_intro($texte, 300))));
			break;
		case 'forums':
			return PtoBR(propre(supprimer_tags(couper_intro($texte, 600))));
			break;
		case 'rubriques':
			if ($descriptif)
				return propre($descriptif);
			else
				return PtoBR(propre(supprimer_tags(couper_intro($texte, 600))));
			break;
	}
}

// fonction appele par les squelettes (insertion dans le code trop lourde)

function query_auteurs($larticle)
{
  $auteurs = "";
  if ($larticle)
    {
      $result_auteurs = spip_query("
SELECT	auteurs.nom, auteurs.email 
FROM	spip_auteurs AS auteurs,
	spip_auteurs_articles AS lien
WHERE	lien.id_article=$larticle
 AND	auteurs.id_auteur=lien.id_auteur
");

      while($row_auteur = spip_fetch_array($result_auteurs)) {
	$nom_auteur = typo($row_auteur["nom"]);
	$email_auteur = $row_auteur["email"];
	if ($email_auteur) {
	  $auteurs[] = "<A HREF=\"mailto:$email_auteur\">$nom_auteur</A>";
	}
	else {
	  $auteurs[] = "$nom_auteur";
	}
      }
    }
  return (!$auteurs) ? "" : join($auteurs, ", ");
}

function boutons_de_forum($idr, $idf, $ida, $idb, $ids, $titre, $table, $Cache, $forum)
{
  // si FORMULAIRE_FORUM a t employ hors d'une boucle,
  // on n'a pas pu dterminer titre et table  la compil
  if (!$table)
    {
      if ($idf)
	{
	  $r = "SELECT titre FROM spip_forum WHERE id_forum = $idf";
	  $table = "forum";
	}
      else if ($idr)
	{
	  $r = "SELECT titre FROM spip_rubriques WHERE id_rubrique = $idr";
	  $table = "rubriques";
	}
      else if ($ida)
	{
	  $r = "SELECT titre FROM spip_articles WHERE id_article = $ida";
	  $table = "articles";
	}
      else if ($idb)
	{
	  $r = "SELECT titre FROM spip_breves WHERE id_breve = $idb";
	  $table = "breves";
	}
      else if ($id_syndic)
	{
	  $table = "syndic";
	  $r = "SELECT nom_site AS titre FROM spip_syndic WHERE id_syndic = $ids";
	}
      else
	{
	  $r = "SELECT '".addslashes(_T('forum_titre_erreur'))."' AS titre";
	}
      $r = spip_fetch_object(spip_query($r));
      $titre = $r->titre;
	}

  $titre = ('> ' . supprimer_numero(ereg_replace ('^[>[:space:]]*', '',$titre)));
  $url = $GLOBALS[HTTP_GET_VARS][url];
  if (!$url) $url = substr($GLOBALS[REQUEST_URI], strrpos($GLOBALS[REQUEST_URI], '/')+1);
  $retour_forum = $GLOBALS['retour'];
  if (!$retour_forum)
    $retour_forum = rawurlencode($url);
  else $retour_forum = ereg_replace('&recalcul=oui','',$retour_forum);

  return ("<form action='$url' method='post'>
	<input type=hidden name='retour' value='$retour_forum'>
	<input type=hidden name='var_cache' value='$Cache[cache]'>
	<input type=hidden name='ajout_forum' value='oui'>
	<input type=hidden name='forum_id_rubrique' value='$idr'>
	<input type=hidden name='forum_id_parent' value='$idf'>
	<input type=hidden name='forum_id_article' value='$ida'>
	<input type=hidden name='forum_id_breve' value='$idb'>
	<input type=hidden name='forum_id_syndic' value='$ids'>
	" .
	(($forum != 'pri') ? '' : ((_T('forum_info_modere'). '<p>'))) .
	"<".
	"?php include_local('inc-forum.php3');
 		lang_select(\$GLOBALS['spip_lang']);
		echo retour_forum('$idr','$idf','$ida','$idb','$ids',\"$titre\",'$table', '$forum');
		lang_dselect();" .
	"?" .
	">\n</form>");
}

?>
