<?php
function parser_texte($texte) {
  while (ereg("<INCLU[DR]E[[:space:]]*\(([-_0-9a-zA-Z./ ]+)\)([^>]*)>", $texte, $match)) {
    $s = $match[0];
    $p = strpos($texte, $s);
    $debut = substr($texte, 0, $p);
    $texte = substr($texte, $p + strlen($s));
    if ($debut)
      {
	$champ = new Texte;
	$champ->texte = $debut;
	$result[] = $champ;
      }
    $champ = new Inclure;
    $champ->fichier = $match[1];
    $p = trim($match[2]);
    if (!$p)
      $champ->params = '';
    else {
      if (!(ereg('^\\{(.*)\\}$', $p, $params)))
	{
	  include("inc-debug-squel.php3");
	  erreur_syntaxe_boucle("Paramtres incorrects", $p,
				"l'inclusion de " . $champ->fichier);
	}
      else $champ->params = split("\}[[:space:]]*\{", $params[1]);
    }
    $result[] = $champ;
  }
  if ($texte)
    {
	$champ = new Texte;
	$champ->texte = $texte;
	$result[] = $champ;
    }

  return $result;
}

function parser_champs($texte) {
  global $champs_traitement, $champs_pretraitement, $champs_posttraitement;

	$result=Array();
	while (ereg('#([A-Z_]+)(\*?)(.*)$', $texte, $regs))
	  {
	    $p = strpos($texte, $regs[0]);
	    if ($p) 
	      $result = array_merge($result,
				    parser_texte(substr($texte, 0, $p)));
	    $texte = $regs[3];
	    $nom_champ = $regs[1];
	    $champ = new Champ;
	    $champ->nom_champ = $nom_champ;
	    $champ->fonctions = $champs_pretraitement[$nom_champ];
	    if (!$regs[2] AND $champs_traitement[$nom_champ]) {
	      reset($champs_traitement[$nom_champ]);
	      while (list(, $f) = each($champs_traitement[$nom_champ])) {
		$champ->fonctions[] = $f;
		}
	    }
	    if ($champs_posttraitement[$nom_champ]) {
	      reset($champs_posttraitement[$nom_champ]);
	      while (list(, $f) = each($champs_posttraitement[$nom_champ])) {
		$champ->fonctions[] = $f;
	      }
	    }
	    $result[] = $champ;
	  }
	return (!$texte ?
		$result :
		array_merge($result, parser_texte($texte)));
}


function parser_champs_etendus($texte) {
  global $champs_valides, $champs_traitement, $champs_pretraitement, $champs_posttraitement;

	while (ereg('\[([^\[]*)\(#([A-Z_]+)(\*?)([^])]*)\)([^]]*)\](.*)$', $texte, $regs)) {
	  $p = strpos($texte, $regs[0]);
	  if ($p) {
	    $c = parser_champs(substr($texte, 0, $p));
	    reset($c);
	    while (list(, $val) = each($c)) $result[] = $val;
	  }
	  $nom_champ = $regs[2];
	  $fonctions = $regs[4];
	  $texte = $regs[6];
	  $champ = new Champ;
	  $champ->nom_champ = $nom_champ;
	  $champ->cond_avant = parser_champs($regs[1]);
	  $champ->cond_apres = parser_champs($regs[5]);
	  $champ->fonctions = $champs_pretraitement[$nom_champ];
	  if (!$regs[3] AND $champs_traitement[$nom_champ]) {
	    reset($champs_traitement[$nom_champ]);
	    while (list(, $f) = each($champs_traitement[$nom_champ])) {
	      $champ->fonctions[] = $f;
	    }
	  }
	  if ($fonctions) {
	    $fonctions = explode('|', ereg_replace("^\|", "", $fonctions));
	    reset($fonctions);
	    while (list(, $f) = each($fonctions)) $champ->fonctions[] = $f;
	  }
	  if ($champs_posttraitement[$nom_champ]) {
	    reset($champs_posttraitement[$nom_champ]);
	    while (list(, $f) = each($champs_posttraitement[$nom_champ])) {
	      $champ->fonctions[] = $f;
	    }
	  }
	  $result[] = $champ;
	}
	return (!$texte ?
		$result :
		array_merge($result, parser_champs($debut.$texte)));
}

function parser_param($params, $result, $idb) {
      $params2 = Array();
      $i = 1;
      while (ereg('^[[:space:]]*\{[[:space:]]*([^ \}])([^\"\}]*)([\"\}])(.*)$', $params, $args)) {
	if ($args[3] == "}")
	  {
	    $params = $args[4];
	    ereg("^(.*[^ \t\n])[[:space:]]*$", $args[2], $m);
	    $param = $args[1] . $m[1];
	    if ($param == 'tout') {
	      $result->tout = true;
	    }
	    else if ($param == 'plat') {
	      $result->plat = true;
	    }
	    else $params2[] = $param;
	  }
	else
	  { 
	    if ($args[1] == '"')
	      {
		if (!ereg("[[:space:]]*\}(.*)$", $params, $m))
		  break;
		else
		  {
		    $params = $m[1];
		    $result->separateur = 
		      ereg_replace("'","\'",$args[2]);
		  }
	      }
	    else
	      {
		if (!ereg("([^\"]*\"[[:space:]]*)\}(.*)$", $args[4], $m))
		  break;
		else
		  {
		    $params = $m[2];
		    $params2[] = $args[1] . $args[2] . '"' . $m[1];
		  }
	      }
	  }
	$i++;
      }
      if ($params)
	{
	  include("inc-debug-squel.php3");
	  erreur_syntaxe_boucle("Paramtre $i (ou suivants) incorrect",
				$params, $idb);
	}
      $result->param = $params2;
}

function parser($texte, $id_parent, $boucles) {

  while (($p = strpos($texte, '<BOUCLE')) ||
	 (substr($texte, 0, strlen('<BOUCLE')) == '<BOUCLE'))
    {

      $debut = substr($texte, 0, $p);
      $milieu = substr($texte, $p);

      if (!ereg("^<BOUCLE([0-9]+|[-_][-_.a-zA-Z0-9]*)[[:space:]]*\(([^)]*)\)[[:space:]]*(([[:space:]]*\{[^}]*\})*)[[:space:]]*>", $milieu, $match)) {
	include("inc-debug-squel.php3");
	erreur_syntaxe_boucle("Boucle incorrecte", '', $milieu);
      }
      $id_boucle = $match[1];

      $result = new Boucle;
      $result->id_parent = $id_parent;
      $result->id_boucle = $id_boucle;

      $type = strtolower($match[2]);
      if (substr($type, 0, 6) == 'boucle') {
	// Rcursion: pas de paramtre, donc presque rien  faire  
	$result->type_requete = 'boucle';
	$result->param = substr($match[2], 6);
      } else {
	if ($type == 'sites') $type = 'syndication';
	$result->type_requete = $type;
	parser_param($match[3], &$result, $id_boucle);
      }

	$s = "<B$id_boucle>";
	$p = strpos($debut, $s);
	if ($p || (substr($debut, 0, strlen($s)) == $s)) {
		$result->cond_avant = substr($debut, $p + strlen($s));
		$debut = substr($debut, 0, $p);
	}

	$milieu = substr($milieu, strlen($match[0]));
	$s = "</BOUCLE$id_boucle>";
	$p = strpos($milieu, $s);
	if ((!$p) && (substr($milieu, 0, strlen($s)) != $s)) 
	  die("<h2>BOUCLE$id_boucle: tag fermant manquant</h2>");

	$texte = substr($milieu, $p + strlen($s));
	$milieu = substr($milieu, 0, $p);

	$s = "</B$id_boucle>";
	$p = strpos($texte, $s);
	if ($p || (substr($texte, 0, strlen($s)) == $s)) {
		$result->cond_fin = substr($texte, 0, $p);
		$texte = substr($texte, $p + strlen($s));
	}

	$s = "<//B$id_boucle>";
	$p = strpos($texte, $s);
	if ($p || (substr($texte, 0, strlen($s)) == $s)) {
		$result->cond_altern = substr($texte, 0, $p);
		$texte = substr($texte, $p + strlen($s));
	}

	$result->cond_avant = parser($result->cond_avant, $id_parent,&$boucles);
	$result->cond_apres = parser($result->cond_fin, $id_parent,&$boucles);
	$result->cond_altern = parser($result->cond_altern, $id_parent,&$boucles);
	$result->milieu = parser($milieu, $id_boucle,&$boucles);
	
	$all_res = array_merge($all_res, parser_champs_etendus($debut));
	$all_res[] = $result;
	if ($boucles[$id_boucle])
	  die ('<h2>BOUCLE'.$id_boucle.': double definition</h2>');
	$boucles[$id_boucle] = $result;
    }
  return array_merge($all_res, parser_champs_etendus($texte));
}

?>
